#ifndef _IOPORT_													//    
#define _IOPORT_

#include <avr/iom128.h>												//  /

#ifndef F_CPU
#warning "F_CPU not defined. Frequency by default 16MHz"
#define F_CPU 16000000UL		/*     (     )*/
#endif

#include <util/delay.h>												//   

#ifndef IO0
#define IO0   0														/* " / I/O 0"*/
#endif
#ifndef IO1
#define IO1   1														/* " / I/O 1"*/
#endif
#ifndef IO2
#define IO2   2														/* " / I/O 2"*/
#endif
#ifndef IO3
#define IO3   3														/* " / I/O 3"*/
#endif
#ifndef IO4
#define IO4   4														/* " / I/O 4"*/
#endif
#ifndef IO5
#define IO5   5														/* " / I/O 5"*/
#endif

#define LOW			0												/* "  "*/
#define HI			1												/* "  "*/
#define Z_STATE		2												/* "  "*/

#ifdef _IO_16_ENABLE_												//    16  -
#define IO6   6														// " / I/O 6"
#define IO7   7														// " / I/O 7"
#define IO8   8														// " / I/O 8"
#define IO9   9														// " / I/O 9"
#define IO10  10													// " / I/O 10"
#define IO11  11													// " / I/O 11"
#define IO12  12													// " / I/O 12"
#define IO13  13													// " / I/O 13"
#define IO14  14													// " / I/O 14"
#define IO15  15													// " / I/O 15"
#endif

//===========================     =============================
//    :
//port_line -  / ( 0  15)
//PullUp-   (0-  GND, 1-  VCC, 2- )
// :
//  (0x01- /0x00- /0xFF-      )

char InLine(unsigned char port_line, char PullUp)
{
//-------------------    6  - --------------------
#ifdef _IO_6_ENABLE_
	char temp;														// 

	if (port_line>5) return 0xFF;									//     ,   
	if (PullUp>2) return 0xFF;										//     ,   
	
	if (port_line<3) temp=port_line+3;								//         
	else temp=port_line-3;
	
	switch(PullUp)
	{
		case 0:
			DDRF|=0x01 << temp;										//    
			PORTF&=~(0x01 << temp);									//  
			break;
		case 1:
			DDRF|=0x01 << temp;										//    
			PORTF|=0x01 << temp;									//  
			break;
		case 2:
			DDRF&=~(0x01 << temp);									// 
			PORTF&=~(0x01 << temp);
	}
	_delay_us(5);													//      
	
	if (port_line<3)
	{
		DDRE&=~(0x01 << (port_line+3));								//   
		_delay_us(5);												//      
		return (PINE >> (port_line+3)) & 0x01;						//  
	}
	else
	{
		DDRB&=~(0x01 << (port_line+2));								//   
		_delay_us(5);												//      
		return (PINB >> (port_line+2)) & 0x01;						//  
	}
#endif
//-------------------    16  - -------------------
#ifdef _IO_16_ENABLE_												//    16  -	
	char result;
	if (port_line>15) return 0xFF;									//     ,   
	if ((PullUp<1) || (PullUp>2)) return 0xFF;						//     ,   
	
	switch (port_line)
	{
		case 0:
			DDRB&=~(0x01 << PB4);									//   
			if (PullUp==1) PORTB|=0x01 << PB4;						//   
			else PORTB&=~(0x01 << PB4);
			_delay_us(5);											//      
			result=(PINB >> PB4) & 0x01;							//  
			break;
		case 1:
			DDRF&=~(0x01 << PF6);									//   
			if (PullUp==1) PORTF|=0x01 << PF6;						//   
			else PORTF&=~(0x01 << PF6);
			_delay_us(5);											//      
			result=(PINF >> PF6) & 0x01;							//  
			break;
		case 2:
			DDRF&=~(0x01 << PF5);									//   
			if (PullUp==1) PORTF|=0x01 << PF5;						//   
			else PORTF&=~(0x01 << PF5);
			_delay_us(5);											//      
			result=(PINF >> PF5) & 0x01;							//  
			break;
		case 3:
			DDRF&=~(0x01 << PF4);									//   
			if (PullUp==1) PORTF|=0x01 << PF4;						//   
			else PORTF&=~(0x01 << PF4);
			_delay_us(5);											//      
			result=(PINF >> PF4) & 0x01;							//  
			break;
		case 4:
			DDRF&=~(0x01 << PF3);									//   
			if (PullUp==1) PORTF|=0x01 << PF3;						//   
			else PORTF&=~(0x01 << PF3);
			_delay_us(5);											//      
			result=(PINF >> PF3) & 0x01;							//  
			break;
		case 5:
			DDRF&=~(0x01 << PF2);									//   
			if (PullUp==1) PORTF|=0x01 << PF2;						//   
			else PORTF&=~(0x01 << PF2);
			_delay_us(5);											//      
			result=(PINF >> PF2) & 0x01;							//  
			break;
		case 6:
			DDRF&=~(0x01 << PF1);									//   
			if (PullUp==1) PORTF|=0x01 << PF1;						//   
			else PORTF&=~(0x01 << PF1);
			_delay_us(5);											//      
			result=(PINF >> PF1) & 0x01;							//  
			break;
		case 7:
			DDRF&=~(0x01 << PF0);									//   
			if (PullUp==1) PORTF|=0x01 << PF0;						//   
			else PORTF&=~(0x01 << PF0);
			_delay_us(5);											//      
			result=(PINF >> PF0) & 0x01;							//  
			break;
		case 8:
			DDRD&=~(0x01 << PD5);									//   
			if (PullUp==1) PORTD|=0x01 << PD5;						//   
			else PORTD&=~(0x01 << PD5);
			_delay_us(5);											//      
			result=(PIND >> PD5) & 0x01;							//  
			break;
		case 9:
			DDRE&=~(0x01 << PE3);									//   
			if (PullUp==1) PORTE|=0x01 << PE3;						//   
			else PORTE&=~(0x01 << PE3);
			_delay_us(5);											//      
			result=(PINE >> PE3) & 0x01;							//  
			break;
		case 10:
			DDRE&=~(0x01 << PE4);									//   
			if (PullUp==1) PORTE|=0x01 << PE4;						//   
			else PORTE&=~(0x01 << PE4);
			_delay_us(5);											//      
			result=(PINE >> PE4) & 0x01;							//  
			break;
		case 11:
			DDRE&=~(0x01 << PE5);									//   
			if (PullUp==1) PORTE|=0x01 << PE5;						//   
			else PORTE&=~(0x01 << PE5);
			_delay_us(5);											//      
			result=(PINE >> PE5) & 0x01;							//  
			break;
		case 12:
			DDRB&=~(0x01 << PB5);									//   
			if (PullUp==1) PORTB|=0x01 << PB5;						//   
			else PORTB&=~(0x01 << PB5);
			_delay_us(5);											//      
			result=(PINB >> PB5) & 0x01;							//  
			break;
		case 13:
			DDRB&=~(0x01 << PB6);									//   
			if (PullUp==1) PORTB|=0x01 << PB6;						//   
			else PORTB&=~(0x01 << PB6);
			_delay_us(5);											//      
			result=(PINB >> PB6) & 0x01;							//  
			break;
		case 14:
			DDRB&=~(0x01 << PB7);									//   
			if (PullUp==1) PORTB|=0x01 << PB7;						//   
			else PORTB&=~(0x01 << PB7);
			_delay_us(5);											//      
			result=(PINB >> PB7) & 0x01;							//  
			break;
		case 15:
			DDRD&=~(0x01 << PD6);									//   
			if (PullUp==1) PORTD|=0x01 << PD6;						//   
			else PORTD&=~(0x01 << PD6);
			_delay_us(5);											//      
			result=(PIND >> PD6) & 0x01;							//  
	}
	return result;													// 
#endif
}

//==========================     ===========================
//    :
//port_line -  / ( 0  15)
//level     -   (0 - /1-)
// :
//0x00-    ,    0xFF

char OutLine(char port_line, char level)
{
//-------------------    6  - --------------------
#ifdef _IO_6_ENABLE_
	if ((port_line>5) || (level>1) ) return 0xFF;					//          ,   
	
	if (port_line<3)
	{
		DDRE|=0x01 << (port_line+3);								//   
		if (level==HI) PORTE|=0x01 << (port_line+3);				//  
		else PORTE&=~(0x01 << (port_line+3));
	}
	else
	{
		DDRB|=0x01 << (port_line+2);								//   
		if (level==HI) PORTB|=0x01 << (port_line+2);				//  
		else PORTB&=~(0x01 << (port_line+2));
	}
	return 0;
#endif
//-------------------    16  - -------------------
#ifdef _IO_16_ENABLE_												//    16  -
	if ((port_line>15) || (level>1) ) return 0xFF;					//          ,   
	
	switch (port_line)
	{
		case 0:
			DDRB|=(0x01 << PB4);									//   
			if (level==HI) PORTB|=(0x01 << PB4);					//  
			else PORTB&=~(0x01 << PB4);
			break;
		case 1:
			DDRF|=(0x01 << PF6);									//   
			if (level==HI) PORTF|=(0x01 << PF6);					//  
			else PORTF&=~(0x01 << PF6);
			break;
		case 2:
			DDRF|=(0x01 << PF5);									//   
			if (level==HI) PORTF|=(0x01 << PF5);					//  
			else PORTF&=~(0x01 << PF5);
			break;
		case 3:
			DDRF|=(0x01 << PF4);									//   
			if (level==HI) PORTF|=(0x01 << PF4);					//  
			else PORTF&=~(0x01 << PF4);
			break;
		case 4:
			DDRF|=(0x01 << PF3);									//   
			if (level==HI) PORTF|=(0x01 << PF3);					//  
			else PORTF&=~(0x01 << PF3);
			break;
		case 5:
			DDRF|=(0x01 << PF2);									//   
			if (level==HI) PORTF|=(0x01 << PF2);					//  
			else PORTF&=~(0x01 << PF2);
			break;
		case 6:
			DDRF|=(0x01 << PF1);									//   
			if (level==HI) PORTF|=(0x01 << PF1);					//  
			else PORTF&=~(0x01 << PF1);
			break;
		case 7:
			DDRF|=(0x01 << PF0);									//   
			if (level==HI) PORTF|=(0x01 << PF0);					//  
			else PORTF&=~(0x01 << PF0);
			break;
		case 8:
			DDRD|=(0x01 << PD5);									//   
			if (level==HI) PORTD|=(0x01 << PD5);					//  
			else PORTD&=~(0x01 << PD5);
			break;
		case 9:
			DDRE|=(0x01 << PE3);									//   
			if (level==HI) PORTE|=(0x01 << PE3);					//  
			else PORTE&=~(0x01 << PE3);
			break;
		case 10:
			DDRE|=(0x01 << PE4);									//   
			if (level==HI) PORTE|=(0x01 << PE4);					//  
			else PORTE&=~(0x01 << PE4);
			break;
		case 11:
			DDRE|=(0x01 << PE5);									//   
			if (level==HI) PORTE|=(0x01 << PE5);					//  
			else PORTE&=~(0x01 << PE5);
			break;
		case 12:
			DDRB|=(0x01 << PB5);									//   
			if (level==HI) PORTB|=(0x01 << PB5);					//  
			else PORTB&=~(0x01 << PB5);
			break;
		case 13:
			DDRB|=(0x01 << PB6);									//   
			if (level==HI) PORTB|=(0x01 << PB6);					//  
			else PORTB&=~(0x01 << PB6);
			break;
		case 14:
			DDRB|=(0x01 << PB7);									//   
			if (level==HI) PORTB|=(0x01 << PB7);					//  
			else PORTB&=~(0x01 << PB7);
			break;
		case 15:
			DDRD|=(0x01 << PD6);									//   
			if (level==HI) PORTD|=(0x01 << PD6);					//  
			else PORTD&=~(0x01 << PD6);
	}
	return 0;
#endif
}
#endif