#ifdef _KEY_ENABLE_													//  
#ifndef _KEY_														//    
#define _KEY_

#include <avr/iom128.h>												//  /

#define UP   0														/* " "*/
#define DOWN 1														/* " "*/
#define LATCH_ON 1													/* " "*/
#define LATCH_OFF 0													/* " "*/
#define LEFT	1													/* " "*/
#define MIDDLE	2													/* " "*/
#define RIGHT	3													/* " "*/

__volatile__ char _Latch[3]={0,0,0};								//    
__volatile__ char _Key_flags;										//   

#define _KEY_TIMER2_
#include "Timer2.h"													//    2

//=============================    ===============================
//    :
//key -  
//sw  -      (0- /1- )
// :
//0x00-        ,    0xFF

char KeyInit(char key, char sw)
{
	if ((key<1) || (key>3) || (sw>1)) return 0xFF;					//         ,   
	
	switch(key)														//    
	{
	case 1:	
		DDRD&=0x7F;													//    
		PORTD|=0x80;												//  
		break;
	case 2:
		DDRD&=0xBF;													//    
		PORTD|=0x40;												//  
		break;
	case 3:
		DDRD&=0xEF;													//    
		PORTD|=0x10;												//  
	}
	_Latch[key-1]=sw;												///    
	_Key_flags&=~(0x01 << (key-1));									//   

#ifdef TIMER2	
	if (sw==1) _Timer2_Enable();									//    2
	sei();															//  	
#endif
	
	return 0;
}

//===========================     ==============================
//    :
//key -  
// :
//  (0x01- /0x00-  /0xFF-   )

char Key(char key)
{
	char temp;														// 	
	
	if ((key<1) || (key>3)) return 0xFF;							//    ,   
	
	if (_Latch[key-1]==0) 
	{
		switch (key)
		{
		case 1: return ((PIND & (1<<PD7)) >> PD7) ^ 0x01;
		case 2: return ((PIND & (1<<PD6)) >> PD6) ^ 0x01;
		case 3: return ((PIND & (1<<PD4)) >> PD4) ^ 0x01;
		}
	}
	else 
	{
		temp=(_Key_flags >> (key-1)) & 0x01;						//  
		_Key_flags&=~(0x01 << (key-1));								//    
		return temp;
	}
	return 0;
}
#endif

#else
#error "This modification has no keys";
#endif